﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            long t = long.Parse(Console.ReadLine());
            long[] A = new long[t], B = new long[t], K = new long[t];
            long[] M = new long[t];
            for (long i = 0; i < t; i++)
            {
                string[] str = Console.ReadLine().Split();
                A[i] = long.Parse(str[0]);
                B[i] = long.Parse(str[1]);
                K[i] = long.Parse(str[2]);
                M[i] = long.Parse(str[3]);
            }

            for (long i = 0; i < t; i++)
            {
                double D = K[i] * K[i] - 4 * (M[i] - K[i] - 1);
                if (D < 0)
                {
                    Console.WriteLine(-1);
                    continue;
                }
                D = Math.Sqrt(D);
                if (D % 1 != 0)
                {
                    Console.WriteLine(-1);
                    continue;
                }
                long Di = (long)D;
                double x1 = (double)(K[i] - Di) / 2;
                double x2 = x1 + Di;
                if (x1 < 0 || x1 % 1 != 0)
                {
                    Console.WriteLine(-1);
                    continue;
                }
                if (x1 < A[i] && x2 < B[i])
                {
                    Console.WriteLine($"{(long)x1} {(long)x2}");
                }
                else if (x2 < A[i] && x1 < B[i])
                {
                    Console.WriteLine($"{(long)x2} {(long)x1}");
                }
                else
                {
                    Console.WriteLine(-1);
                }
            }
        }
    }
}
