﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp3
{
    class Program
    {
        static void Main(string[] args)
        {
            string[] straus = Console.ReadLine().Split();
            long k = long.Parse(straus[0]);
            long n = long.Parse(straus[1]);
            char[] D = new char[n];
            long[] A = new long[n];
            for (long i = 0; i < n; i++)
            {
                straus = Console.ReadLine().Split();
                D[i] = straus[0][0];
                A[i] = long.Parse(straus[1]);
            }
            Rect[] R = new Rect[n + 1];


            long area = k * k;
            R[0] = new Rect(0, k, k, 0);
            Rect rect = new Rect(0, k, k, 0);
            for (long i = 0; i < n; i++)
            {
                area += A[i] * k;
                switch (D[i])
                {
                    case 'N':
                        R[i + 1] = new Rect
                        (
                            x1: rect.x1,
                            x2: rect.x2,
                            y1: rect.y1 + A[i],
                            y2: rect.y1
                        );
                        rect.y1 = R[i + 1].y1;
                        rect.y2 = rect.y1 - k;
                        break;
                    case 'S':
                        R[i + 1] = new Rect
                        (
                            x1: rect.x1,
                            x2: rect.x2,
                            y1: rect.y2,
                            y2: rect.y2 - A[i]
                        );
                        rect.y2 = R[i + 1].y2;
                        rect.y1 = rect.y2 + k;
                        break;
                    case 'W':
                        R[i + 1] = new Rect
                        (
                            x1: rect.x1 - A[i],
                            x2: rect.x1,
                            y1: rect.y1,
                            y2: rect.y2 
                        );
                        rect.x1 = R[i + 1].x1;
                        rect.x2 = rect.x1 + k;
                        break;
                    case 'E':
                        R[i + 1] = new Rect
                        (
                            x1: rect.x2,
                            x2: rect.x2 + A[i],
                            y1: rect.y1,
                            y2: rect.y2 
                        );
                        rect.x2 = R[i + 1].x2;
                        rect.x1 = rect.x2 - k;
                        break;
                }
                for (int j = 0; j < i; j++)
                {
                    area -= R[i + 1].SubArea(R[i]);
                }
            }
            Console.WriteLine(area);
        }
        class Rect
        {
            public Rect(long x1, long y1, long x2, long y2)
            {
                this.x1 = x1;
                this.y1 = y1;
                this.x2 = x2;
                this.y2 = y2;
            }
            public long x1, y1, x2, y2;
            public long SubArea(Rect rect)
            {
                long dy = Min(Max(rect.y1 - Max(rect.y2, y2), 0), Max(y1 - Max(y2, rect.y2), 0));
                long dx = Min(Max(rect.x2 - Max(rect.x1, x1), 0), Max(x2 - Max(rect.x1, x1), 0));
                return dx * dy;
            }
            static long Min(long a, long b) => a < b ? a : b;
            static long Max(long a, long b) => a > b ? a : b;
            static long Abs(long a) => Math.Abs(a);
        }
    }
}
