﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp4
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.ReadLine();
            int q = int.Parse(Console.ReadLine());
            for (int i = 0; i < q; i++)
            {
                string str = Console.ReadLine();
                int[,] d = new int[3, 3];
                int prev = -1;
                switch (str[0])
                {
                    case 'a':
                        prev = 0;
                        break;
                    case 'b':
                        prev = 1;
                        break;
                    case 'c':
                        prev = 2;
                        break;
                }
                for (int j = 1; j < str.Length; j++)
                {
                    switch (str[j])
                    {
                        case 'a':
                            d[prev, 0]++;
                            prev = 0;
                            break;
                        case 'b':
                            d[prev, 1]++;
                            prev = 1;
                            break;
                        case 'c':
                            d[prev, 2]++;
                            prev = 2;
                            break;
                    }
                }
                Console.WriteLine(cnt(d, 0) + cnt(d, 1) + cnt(d, 2));
            }
        }
        const long _D = 1_000_000_007;
        static long cnt(int[,] d, int p)
        {
            long sum = 0;
            for (int i = 0; i < 3; i++)
            {
                for (int j = 0; j < 3; j++)
                {
                    sum += d[i, j];
                }
            }
            if (sum == 0)
            {
                return 1;
            }
            long cn = 0;
            for (int j = 0; j < 3; j++)
            {
                if (d[p,j] > 0)
                {
                    d[p,j]--;
                    cn += cnt(d, j);
                    d[p, j]++;
                }
            }
            return cn % _D;
        }
    }
}
